// src/index.ts
import { mergeAndCompare, merge } from "merge-anything";
function isFunction(value) {
  return typeof value === "function";
}
function mergeFn(origin, override) {
  if (isFunction(origin) || isFunction(override)) {
    return (...args) => {
      const originValue = isFunction(origin) ? origin(...args) : origin;
      const overrideValue = isFunction(override) ? override(...args) : override;
      return mergeAndCompare(mergeFn, {}, originValue, overrideValue);
    };
  }
  if (Array.isArray(origin) || Array.isArray(override)) {
    return (origin != null ? origin : []).concat(override != null ? override : []);
  }
  return override;
}
function mergeWith(...overrides) {
  return mergeAndCompare(mergeFn, {}, ...overrides);
}
export {
  merge,
  mergeWith
};
